## Hinweis:
Der vorliegende JMeter-Test ermöglicht die Testung der Verbindung zwischen Ihrem System und der federated Trusted Third Party (fTTP). Dabei sind bereits Test-Bloomfilter hinterlegt, sodass der Test ohne angebundene Treuhandstelle auskommt. Ziel ist es, dass der Test erfolgreich ausgeführt werden kann und im Ergebnis die fTTP DIZ-Pseudonyme liefert. Ihr System hat sich dann erfolgreich mit der fTTP verbunden.

## Zur Ausführung des Tests sind folgende Schritte nötig:
1. Installieren Sie JMeter auf dem zu testenden System (https://jmeter.apache.org/).
2. Hinterlegen Sie das von der fTTP erhaltene Client-Zertifikat. Die hierzu nötigen Schritte sind in ```HowTo-Client-Zertifikat_mit_jmeter.md``` hinterlegt.
3. Passen Sie den JMeter-Test an. Die Änderungen können über die Oberfläche von JMeter durchgeführt werden (JMeter starten -> Test laden (```fTTP-W-2022.2 - fTTP-W-Person-registrieren-Test.jmx```)). Sollte Ihnen ausschließlich ein Zugang per Konsole zur Verfügung stehen, können Sie die mitgelieferte ```2022.2 - fTTP-W-Person-registrieren-Test.jmx``` mit einem beliebigen Texteditor bearbeiten. Die zu ändernden Parameter sind im Folgendem aufgeführt, sodass Sie einfach danach suchen können. Die erforderlichen Änderungen umfassen die folgenden Schritte:
    - Passen Sie die Variablen "DIZ Variablen" an. Tragen Sie Ihren API-Key und die Target-Domäne ein. Beides erhalten Sie nach erfolgreicher Antragsstellung von der fTTP (```HIER_API_KEY_EINTRAGEN``` und ```HIER_DOMÄNE_EINTRAGEN (dic_...)```).
    - Wenn Sie einen Zugang auf Login-Basis beantragt haben, dann tragen Sie Ihre Zugangsdaten unter ```HTTP Autorisierung (nur bei Login)``` ein (```HIER_LOGIN_BENUTZERNAME_EINTRAGEN``` und ```HIER_LOGIN_PASSWORT_EINTRAGEN```). Wenn Sie im Texteditor die Anpassungen vornehmen, dann aktivieren Sie zusätzlich den Eintrag, indem Sie den Wert `enabled="false"` in `AuthManager` auf `true` ändern. In der Oberfläche können Sie im linken Rand den Eintrag auswählen und per Rechtsklick das Kontextmenü öffnen. Wenn Sie den Eintrag *Enable* aufrufen, wird die entsprechende Komponenten aktiviert. Wenn Sie ausschließlich einen Zugang per IP-Adresse/-Bereich, brauchen Sie hier nichts tun.
4. Starten Sie den JMeter-Test (GUI: Grüner Pfeil; Konsole: ```jmeter -n -t 2022.2 - fTTP-W-Person-registrieren-Test.jmx```). Es werden dabei zwei Anfragen an die fTTP gestellt. Die erste übermittelt einen Bloomfilter. Die zweite Anfrage übermittelt gleichzeitig zwei Bloomfilter an die fTTP.
5. Bei erfolreicher Anbindung wird eine Datei ```results.txt``` angelegt. Darin werden die zurückgelieferten DIZ-Pseudonyme eingetragen. Das Format ist ```dic_*****```. Stellen Sie ggf. die Schreibberechtigung sicher.
6. Wurde der Test erfolgreich durchgeführt, kann Ihr System mit der fTTP kommunizieren. Sollten sich keine DIZ-Pseudonyme in der Datei befinden, überprüfen Sie bitte Ihre Verbindungsdaten. Wenden Sie sich bei weiteren Fragen an fttp-num@uni-greifswald.de. 
